# Avoid running unnecessary services on the Gitaly server
postgresql['enable'] = {{ postgresql_enable }}
redis['enable'] = {{ redis_enable }}
nginx['enable'] = {{ nginx_enable }}
puma['enable'] = {{ puma_enable }}
sidekiq['enable'] = {{ sidekiq_enable }}
gitlab_workhorse['enable'] = {{ gitlab_workhorse_enable }}
alertmanager['enable'] = {{ alertmanager_enable }}
prometheus['enable'] = {{ prometheus_enable }}
gitlab_kas['enable'] = {{ gitlab_kas_enabled }}
gitlab_exporter['enable'] = {{ gitlab_exporter_enabled }}

# Prevent database migrations from running on upgrade automatically
gitlab_rails['auto_migrate'] = {{ db_auto_migrate }}

# Configure the gitlab-shell API callback URL. Without this, `git push` will
# fail. This can be your 'front door' GitLab URL or an internal load
# balancer.
# Don't forget to copy `/etc/gitlab/gitlab-secrets.json` from web server to Gitaly server.
gitlab_rails['internal_api_url'] = 'https://{{ external_url }}'

################################################################################
## Gitaly configuration
##
################################################################################
gitaly['enable'] = {{ gitaly_enable }}
gitaly['configuration'] = {
  listen_addr: '{{ gitaly.listen_addr }}',
{% if gitaly.tls_listen_addr is defined and gitaly.tls_listen_addr|length %}
  tls_listen_addr: '{{ gitaly.tls_listen_addr }}',
  tls: {
    certificate_path: '{{ gitaly.tls.certificate_path }}',
    key_path: '{{ gitaly.tls.key_path }}',
  },
{% endif %}
{% if gitaly.storages is defined and gitaly.storages|length %}
  storage: [
{% for storage in gitaly.storages %}
    {
      name: '{{ storage.name }}',
      path: '{{ storage.path }}/repositories',
    },
{% endfor %}
  ],
{% endif %}
  socket_path: '{{ gitaly.socket_path }}',
  runtime_dir: '{{ gitaly.runtime_dir }}',
  prometheus_listen_addr: '{{ gitaly.prometheus_listen_addr }}',
  graceful_restart_timeout: '{{ gitaly.graceful_restart_timeout }}',
  logging: {
    level: '{{ gitaly.logging.level }}',
    format: '{{ gitaly.logging.format }}',
{% if gitaly.logging.sentry_dsn is defined and gitaly.logging.sentry_dsn|length %}
    sentry_dsn: '{{ gitaly.logging.sentry_dsn }}',
{% endif %}
{% if gitaly.logging.ruby_sentry_dsn is defined and gitaly.logging.ruby_sentry_dsn|length %}
    ruby_sentry_dsn: '{{ gitaly.logging.ruby_sentry_dsn }}',
{% endif %}
    sentry_environment: '{{ gitaly.logging.sentry_environment }}',
    dir: '{{ gitaly.logging.dir }}',
  },
  prometheus: {
    grpc_latency_buckets: [{{ gitaly.prometheus.grpc_latency_buckets | join(', ')}}],
  },
  auth: {
    token: '{{ gitaly.auth.token }}',
    transitioning: {{ gitaly.auth.transitioning }},
  },
  git: {
    catfile_cache_size: {{ gitaly.git.catfile_cache_size }},
{% if gitaly.git.bin_path is defined and gitaly.git.bin_path|length %}
    bin_path: '{{ gitaly.git.bin_path }}',
{% endif %}
{% if gitaly.git.use_bundled_binaries is defined %}
    use_bundled_binaries: {{ gitaly.git.use_bundled_binaries }},
{% endif %}
{% if gitaly.git.signing_key is defined and gitaly.git.signing_key|length %}
    signing_key: '{{ gitaly.git.signing_key }}',
{% endif %}
{% if gitaly.git.config is defined and gitaly.git.config|length %}
    config: [
{% for key, value in gitaly.git.config.items() %}
      {
        key: '{{ key }}',
        value: '{{ value }}',
      },
{% endfor %}
    ],
{% endif %}
  },
  hooks: {
    custom_hooks_dir: '{{ gitaly.hooks.custom_hooks_dir }}',
  },
  daily_maintenance: {
    disabled: {{ gitaly.daily_maintenance.disabled }},
    start_hour: {{ gitaly.daily_maintenance.start_hour }},
    start_minute: {{ gitaly.daily_maintenance.start_minute }},
    duration: '{{ gitaly.daily_maintenance.duration }}',
{% set maintain_storages = [] %}{% for storage in gitaly.storages %}{{ maintain_storages.append(storage.name) }}{% endfor %}
    storages: ['{{ maintain_storages | join(', ')}}'],
  },
{% if gitaly.cgroups.enabled %}
  cgroups: {
    mountpoint: '{{ gitaly.cgroups.mountpoint }}',
    hierarchy_root: '{{ gitaly.cgroups.hierarchy_root }}',
    memory_bytes: {{ gitaly.cgroups.memory_bytes }},
    cpu_shares: {{ gitaly.cgroups.cpu_shares }},
    repositories: {
       count: {{ gitaly.cgroups.repositories.count }},
       memory_bytes: {{ gitaly.cgroups.repositories.memory_bytes }},
       cpu_shares: {{ gitaly.cgroups.repositories.cpu_shares }},
    },
  },
{% endif %}
{% if gitaly.concurrency is defined and gitaly.concurrency|length %}
  concurrency: [
{% for key, value in gitaly.concurrency.items() %}
    {
{% if value is number %}
      {{ key }}: {{ value }},
{% else %}
       {{ key }}: '{{ value }}',
{% endif %}
    },
{% endfor %}
  ],
{% endif %}
{% if gitaly.rate_limiting is defined and gitaly.rate_limiting|length %}
  rate_limiting: [
{% for key, value in gitaly.rate_limiting.items() %}
    {
{% if value is number %}
      {{ key }}: {{ value }},
{% else %}
       {{ key }}: '{{ value }}',
{% endif %}
    },
{% endfor %}
  ],
{% endif %}
{% if gitaly.pack_objects_cache.enabled %}
  pack_objects_cache: {
    enabled: true,
    dir: '{{ gitaly.pack_objects_cache.dir }}',
    max_age: {{ gitaly.pack_objects_cache.max_age }},
  },
{% endif %}
}

################################################################################
## Prometheus Node Exporter
##! Docs: https://docs.gitlab.com/ee/administration/monitoring/prometheus/node_exporter.html
################################################################################

node_exporter['enable'] = {{ node_exporter_enable }}
{% if node_exporter_enable == "true" %}
node_exporter['home'] = '{{ node_exporter_home }}'
node_exporter['log_directory'] = '{{ node_exporter_log_directory }}'
node_exporter['flags'] = {
{% for key, value in node_exporter_flags.items() %}
  '{{ key }}' => "{{ value }}"
{% endfor %}
}
node_exporter['env_directory'] = '{{ node_exporter_env_directory }}'
node_exporter['env'] = {
{% for key, value in node_exporter_environment_variables.items() %}
  '{{ key }}' => "{{ value }}"
{% endfor %}
}

##! Advanced settings. Should be changed only if absolutely needed.
node_exporter['listen_address'] = '{{ node_exporter_listen_address }}'
{% endif %}